-- *** Radio Toggle 0.1 by 80T *** --


----------- Config Start ------------

local toggleKey = Keys.Subtract			-- Toggle Radio On/Off Key (Default: "Keys.Subtract" ["-" Minus])
local randomKey = Keys.Multiply			-- Random Radio Station Key (Default: "Keys.Multiply" ["*" Asterisk])
local skipfwKey = Keys.Divide			-- Random Radio Station Key (Default: "Keys.Divide" ["/" Slash])
local defStation = 17 -- [0-17]			-- Set to any Station Index you would like the Radio to start with. (Default: "17" ["Self Radio"])
local setDefault = false				-- Start Radio with the custom set Radio Station ? (Default: "false")
local radioOff = false					-- Set the Radio initial state to Off ? (Default: "false")
------------ Config End -------------

--local RadioStations = {				-- Params: {Station Index, Station Name}
--	{0, "RADIO_01_CLASS_ROCK"},			-- Los Santos Rock Radio
--	{1, "RADIO_02_POP"},				-- Non-Stop-Pop FM
--	{2, "RADIO_03_HIPHOP_NEW"},			-- Radio Los Santos
--	{3, "RADIO_04_PUNK"},				-- Channel X
--	{4, "RADIO_06_COUNTRY"},			-- Rebel Radio
--	{5, "RADIO_07_DANCE_01"},			-- Soulwax FM
--	{6, "RADIO_08_MEXICAN"},			-- East Los FM
--	{7, "RADIO_09_HIPHOP_OLD"},			-- West Coast Classics
--	{8, "RADIO_11_TALK_02"},			-- Blaine County Radio
--	{9, "RADIO_12_REGGAE"},				-- Blue Ark
--	{10, "RADIO_13_JAZZ"},				-- Worldwide FM
--	{11, "RADIO_14_DANCE_02"},			-- FlyLo FM
--	{12, "RADIO_15_MOTOWN"},			-- The Lowdown 91.1
--	{13, "RADIO_20_THELAB"},			-- The Lab
--	{14, "RADIO_16_SILVERLAKE"},		-- Radio Mirror Park
--	{15, "RADIO_17_FUNK"},				-- Space 103.2
--	{16, "RADIO_18_90S_ROCK"},			-- Vinewood Boulevard Radio
--	{17, "RADIO_19_USER"},				-- Self Radio
--	{255, "OFF"}						-- Radio Off
--}

local lastVeh = false
local checkVeh = true
local toggleDef = false
local isTuning = false
local getLast = true
local keyPressToggle = false
local keyPressRand = false
local keyPressSkip = false
local rndFunc = true
local skipFunc = true
local rndInit = 0
local skipInit = 0
local maxStation = 255
local tempStation = 255
local lastStation = 255
local prevStation = 255

local RadioToggle = {}

function RadioToggle.unload()
end

function RadioToggle.init()
	print('*** Radio Toggle 0.1 by 80T ***')
end

function RadioToggle.tick()
	local playerPed = PLAYER.PLAYER_PED_ID()
	local playerExists = ENTITY.DOES_ENTITY_EXIST(playerPed)
	local stationIndex = AUDIO.GET_PLAYER_RADIO_STATION_INDEX()
	local userStation = AUDIO.GET_RADIO_STATION_NAME(17)

	-- "RADIO_05_TALK_01" = Self Radio N/A --
	
	if userStation == "RADIO_19_USER" then
		maxStation = 17
	else
		maxStation = 16
	end
	
	if AUDIO.IS_RADIO_RETUNING() then
		isTuning = true
	else
		if getLast then
			lastStation = AUDIO.GET_PLAYER_RADIO_STATION_INDEX()
			getLast = false
		end
	end
	
	if isTuning then
		prevStation = lastStation
		isTuning = false
	else
		getLast = true
	end
	
	if(playerExists) then
		if(PED.IS_PED_IN_ANY_VEHICLE(playerPed, false)) then
			local currVeh = PED.GET_VEHICLE_PED_IS_IN(playerPed, true)
			
			if checkVeh then
				if currVeh == PLAYER.GET_PLAYERS_LAST_VEHICLE() then
					lastVeh = true
				else
					lastVeh = false
				end
				checkVeh = false
			end
			
			if setDefault and not lastVeh then
				if defStation == 255 then
					defStation = math.random(0, maxStation)
				elseif defStation == 17 and maxStation == 16 then
					defStation = math.random(0, maxStation)
				end
				
				if radioOff then
					if stationIndex ~= 255 then
						AUDIO.SET_RADIO_TO_STATION_NAME("OFF")
						setDefault = true
					else
						tempStation = defStation
						setDefault = false
					end
				else
					AUDIO.SET_RADIO_TO_STATION_INDEX(defStation)
					setDefault = false
				end
				toggleDef = true
			end
			
			if get_key_pressed(toggleKey) then
				keyPressToggle = true
			elseif keyPressToggle then
				if stationIndex ~= 255 then
					tempStation = stationIndex
					AUDIO.SET_RADIO_TO_STATION_NAME("OFF")
					keyPressToggle = false
				else
					AUDIO.SET_RADIO_TO_STATION_INDEX(tempStation)
					keyPressToggle = false
				end
			end
			
			if stationIndex ~= 255 then
				if get_key_pressed(randomKey) then
					if rndFunc then
						rndInit = GAMEPLAY.GET_GAME_TIMER()
						rndFunc = false
					end
					keyPressRand = true
				elseif keyPressRand then
					if GAMEPLAY.GET_GAME_TIMER() - rndInit < 250 then
						local rand = math.random(0, maxStation)
						while stationIndex ~= rand do
							AUDIO.SET_RADIO_TO_STATION_INDEX(rand)
							keyPressRand = false
							rndFunc = true
							break
						end
					else
						if stationIndex ~= defStation then
							AUDIO.SET_RADIO_TO_STATION_INDEX(defStation)
						end
						keyPressRand = false
						rndFunc = true
					end
				end
				
				if get_key_pressed(skipfwKey) then
					if skipFunc then
						skipInit = GAMEPLAY.GET_GAME_TIMER()
						skipFunc = false
					end
					keyPressSkip = true
				elseif keyPressSkip then
					if GAMEPLAY.GET_GAME_TIMER() - skipInit < 250 then
							AUDIO.SET_RADIO_TO_STATION_INDEX(prevStation)
							keyPressSkip = false
							skipFunc = true
						else
							AUDIO.SKIP_RADIO_FORWARD()
							keyPressSkip = false
							skipFunc = true
						end
				end
			end
		else
			checkVeh = true
			if toggleDef then
				setDefault = true
			end
		end
	end
end

return RadioToggle